<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class BotMetricsMetadata extends \Google\Protobuf\Internal\Message
{
    


    protected $destinationId = null;
    


    protected $destinationEntryPoint = null;
    


    protected $threadOrigin = null;

    










    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getDestinationId()
    {
        return isset($this->destinationId) ? $this->destinationId : '';
    }

    public function hasDestinationId()
    {
        return isset($this->destinationId);
    }

    public function clearDestinationId()
    {
        unset($this->destinationId);
    }

    




    public function setDestinationId($var)
    {
        GPBUtil::checkString($var, True);
        $this->destinationId = $var;

        return $this;
    }

    



    public function getDestinationEntryPoint()
    {
        return isset($this->destinationEntryPoint) ? $this->destinationEntryPoint : 0;
    }

    public function hasDestinationEntryPoint()
    {
        return isset($this->destinationEntryPoint);
    }

    public function clearDestinationEntryPoint()
    {
        unset($this->destinationEntryPoint);
    }

    




    public function setDestinationEntryPoint($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\BotMetricsEntryPoint::class);
        $this->destinationEntryPoint = $var;

        return $this;
    }

    



    public function getThreadOrigin()
    {
        return isset($this->threadOrigin) ? $this->threadOrigin : 0;
    }

    public function hasThreadOrigin()
    {
        return isset($this->threadOrigin);
    }

    public function clearThreadOrigin()
    {
        unset($this->threadOrigin);
    }

    




    public function setThreadOrigin($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\BotMetricsThreadEntryPoint::class);
        $this->threadOrigin = $var;

        return $this;
    }

}

